\documentclass[]{article}
\usepackage{bm}
\usepackage{graphicx}
\usepackage{float}
\usepackage{subcaption}
%
%opening
\title{IPPR Assignment 1}
\author{Marcus Ackerl, 01330813\\Gabriel Weissenbaeck, 01610048}
%
\begin{document}
%
\maketitle%

\section*{Task 3.1 Guided Image Filtering}
The task was to implement the Guided Image Filtering algorithm from the assignment sheet.
The functionality of the filter was tested with the provided input-output image pair. In figure \ref{fig:3.1}, the resulting image is shown, as is the original input and the reference output. For the reference picture edge preservation filtering was used where the same picture is used as input and guide image. Compared to the reference, our implementation of the guided image filter seemed to work fine. 

\begin{figure}[H]
	\centering
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{../imgs/edge_pres_filtering/input.png}
		\caption{Original Input}
	\end{subfigure}\\
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/edge_pres_filtering/out_r_4_eps_0.04_compare}.png}
		\caption{Reference Output}
		%\label{fig:4a_sc}
	\end{subfigure}%
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/edge_pres_filtering/out_r_4_eps_0.0400}.png}
		\caption{Resulting Output}
		%\label{fig:4a_wd}
	\end{subfigure}
	\caption{Input, reference, and resulting images for Task 3.1}
	\label{fig:3.1}
\end{figure}

\section*{Task 3.2 Dehazing}
Here, we should implement a dehazing algorithm, that, with the use of guided filtering, removes turbid medium like mist from images. In \ref{fig:3.2}, the comparison between the original input and the dehazed output is shown. As one can observe, the haze, resembling a thick mist is removed, while the original colors are preserved.
In figure \ref{fig:3.2.1}, the intermediate results from computing the transmission image is shown. Here the influence of the filter is visible.\\
\\
In the transmission plots, the influence of the guided filter can be observed, as it smooths out the edges, which is especially visible at the edge where the treeline ends.\\
\\
The transmission visually approximates the inverse of the brightness of the image (similar to a inverse grayscale image), but not pixel-wise but patch-wise, leading to a very "pixelated" look, where quadratic patches have the same gray-value.\\
\\
This pixelated look would in way also be introduced in the restored image, if the transmission wouldn't be refined. This is shown in figure \ref{fig:3.2.2}, where the image contains some horizontal or vertical brightness jumps, that are introduced through the quadratic transmission patches.\\
\\
The filter parameters were chosen as $r=20$ and $\epsilon = 0.001$. This smooths out the patch borders, as explained in the previous paragraph, but still keeps most details in the result.
\begin{figure}[H]
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/dehazing/input}.png}
		\caption{Original Input}
		%\label{fig:4a_sc}
	\end{subfigure}%
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/dehazing/restored}.png}
		\caption{Restored Output}
		%\label{fig:4a_wd}
	\end{subfigure}
	\caption{Resulting output of the dehazing algorithm from task 3.2}
	\label{fig:3.2}
\end{figure}
\begin{figure}[H]
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/dehazing/te}.png}
		\caption{Transmission}
		%\label{fig:4a_sc}
	\end{subfigure}%
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/dehazing/t}.png}
		\caption{Filtered Transmission}
		%\label{fig:4a_wd}
	\end{subfigure}
	\caption{Estimated (a) and refined (b) transmission map for task 3.2}
	\label{fig:3.2.1}
\end{figure}
\begin{figure}[H]
	\centering
	\includegraphics[width=.5\linewidth]{{../imgs/dehazing/restored_unrefined}.png}
	\caption{Result of the dehazing without refining of the transmission map, Task 3.2}
	\label{fig:3.2.2}
\end{figure}

\section*{Task 3.3 Flash-No-Flash Denoising}
Here, the task was to use the Guided Image Filter on an image pair, where one image is shot in rather dark surroundings while the other image is the exact same scene, but shot with flash.
The flash image is then used as the guidance image to filter the low light image. The images were to be shot by ourselves. The problem here is, that the constraint to shoot 2 exact same scenes is rather hard to satisfy with a smartphone camera. The input pair is shown in \ref{fig:3.3}, whereas the resulting outputs for different parameter choices is shown in \ref{fig:3.3.1}.\\
\\
The resulting outputs show, beside from being pretty bad overall, which is probably due to the non-perfect overlap of input and guide image, that the r-parameter mainly influences the overall blurriness in rather "linear" manner, as it rises with the r-value. The $\epsilon$-parameter seems to influence the display of edges in different manner, as a difference of only 0.01 leads to a visibly stronger "boost" of the edges in the image.
\begin{figure}[H]
	\centering
	\begin{subfigure}{\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/ftf/input}.png}
		\caption{Low-Light image}
		%\label{fig:4a_sc}
	\end{subfigure}\\
	\begin{subfigure}{\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/ftf/guide}.png}
		\caption{Flash image}
		%\label{fig:4a_wd}
	\end{subfigure}
	\caption{Input images for Task 3.3}
	\label{fig:3.3}
\end{figure}
\begin{figure}[H]
	\centering
	\begin{subfigure}{\textwidth}
		\centering
		\includegraphics[width=.8\linewidth]{{../imgs/ftf/out_r_3_eps_0.0200}.png}
		\caption{r=3, $\epsilon$ = 0.02}
		%\label{fig:4a_sc}
	\end{subfigure}\\
	\begin{subfigure}{\textwidth}
		\centering
		\includegraphics[width=.8\linewidth]{{../imgs/ftf/out_r_3_eps_0.0400}.png}
		\caption{r=3, $\epsilon$ = 0.04}
		%\label{fig:4a_wd}
	\end{subfigure}\\
	\begin{subfigure}{\textwidth}
		\centering
		\includegraphics[width=.8\linewidth]{{../imgs/ftf/out_r_4_eps_0.0400}.png}
		\caption{r=4, $\epsilon$ = 0.04}	%\label{fig:4a_wd}
	\end{subfigure}
	\caption{Resulting images with their respective parameters for Task 3.3}
	\label{fig:3.3.1}
\end{figure}
\section*{Task 3.4 Detail Enhancement}
In task 3.4 we should use the Guided Image Filter to perform detail enhancement. For detail enhancement the input image is also used as the guide image for the edge preservation algorithm. Every pixel in the resulting image can be calculated with equation \ref{eqn:detail}, where $c^{de}$ represents the detail enhancement coefficient, $p$ is the input image and $q$ is the output of the guided image filter and $p^{de}$ is the resulting image.\\
\begin{equation}
	\label{eqn:detail}
	p_{i}^{de} = c^{de}(p_{i}-q_{i})+q_{i}
\end{equation}
\\
 Since $q$ is the output of the edge preservation filter, the edges in the image are pronounced. As we add $q$ at the end of Equation \ref{eqn:detail}, it makes sense that the details in form of edges and creases are attenuated in the resulting image. \\
 \\
 In figure \ref{fig:3.4}, the input as well as the resulting outputs for different enhancement parameters are shown. All enhancements were done with $r = 4$ and $\epsilon = 0.04$. In these results, the detail enhancement can be seen very well. However, it also appears that the detail enhancement reduces the overall contrast of the image leading to a certain "grayness" of the output. This grayness is proportional to the detail enhancement coefficient $c^{de}$. \\
 \\
 Figure \ref{fig:3.5} shows the results of the same input image and detail enhancement algorithm, but with parameters $r = 8$ and $\epsilon = 0.01$. Compared to the outputs in Figure 7, the difference that stands out the most is in the sharpness, or the level of detail of the final results. If we just concentrate on the output that is enhanced with $c^{de}=3$, the higher r seems to slightly reduce the greyness effect. On the other hand, the detail enhancement effect is also not as strong as with a smaller r. This can be explained due to the filter size growing proportional to r. With a larger filter size for a larger r, the output in Figure 8 has some details lost due to the larger filter.    \\
 \\
 Figure \ref{fig:3.6} shows the results of the detail enhancement algorithm applied on a smartphone image. One can see that the little creases on the leafs are more visible, the greater the detail enhancement coefficient $c^{de}$ is. 
\begin{figure}[H]
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/detail_enhancement/input}.png}
		\caption{Input}
		%\label{fig:4a_sc}
	\end{subfigure}%
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/detail_enhancement/out_c_0.5r_4_eps_0.0400}.png}
		\caption{$c^{de} = 0.5$}
		%\label{fig:4a_wd}
	\end{subfigure}\\
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/detail_enhancement/out_c_1.5r_4_eps_0.0400}.png}
		\caption{$c^{de} = 1.5$}
		%\label{fig:4a_wd}
	\end{subfigure}%
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/detail_enhancement/out_c_3r_4_eps_0.0400}.png}
		\caption{$c^{de} = 3$}
		%\label{fig:4a_wd}
	\end{subfigure}
	\caption{Input and resulting images with $r = 4$ and $\epsilon = 0.04$}
	\label{fig:3.4}
\end{figure}
\begin{figure}[H]
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/detail_enhancement/input}.png}
		\caption{Input}
		%\label{fig:4a_sc}
	\end{subfigure}%
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/detail_enhancement/out_c_0.5r_8_eps_0.0100}.png}
		\caption{$c^{de} = 0.5$}
		%\label{fig:4a_wd}
	\end{subfigure}\\
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/detail_enhancement/out_c_1.5r_8_eps_0.0100}.png}
		\caption{$c^{de} = 1.5$}
		%\label{fig:4a_wd}
	\end{subfigure}%
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{{../imgs/detail_enhancement/out_c_3r_8_eps_0.0100}.png}
		\caption{$c^{de} = 3$}
		%\label{fig:4a_wd}
	\end{subfigure}
	\caption{Input and resulting images with $r = 8$ and $\epsilon = 0.01$}
	\label{fig:3.5}
\end{figure}
\begin{figure}[H]
	\begin{subfigure}{\textwidth}
		\centering
		\includegraphics[width=.8\linewidth]{{../imgs/ftf/out_detail_c_1.5_r_4_eps_0.0400}.png}
		\caption{$c^{de} = 1.5$}
	\end{subfigure}\\
	\begin{subfigure}{\textwidth}
		\centering
		\includegraphics[width=.8\linewidth]{{../imgs/ftf/out_detail_c_3_r_4_eps_0.0400}.png}
		\caption{$c^{de} = 3$}
	\end{subfigure}\\
	\begin{subfigure}{\textwidth}
		\centering
		\includegraphics[width=.8\linewidth]{{../imgs/ftf/out_detail_c_4_r_4_eps_0.0400}.png}
		\caption{$c^{de} = 4$}
	\end{subfigure}
	\caption{Results of the detail enhancement on a smartphone image}
	\label{fig:3.6}
\end{figure}
\end{document}